Package net.sf.saxon.functions.registry

## Class OnDemandFunctionSet

- java.lang.Object
- - net.sf.saxon.functions.registry.OnDemandFunctionSet

- All Implemented Interfaces:
    `FunctionLibrary`

      public class OnDemandFunctionSet
      extends java.lang.Object
      implements FunctionLibrary

  The `OnDemandFunctionSet` represents a function library where the implementation classes are loaded dynamically on demand. The idea is that no failure should occur if implementations are not available unless the functions are actually required. The class contains the name of a real FunctionLibrary containing the function implementations; that FunctionLibrary is dynamically loaded if an attempt is made to bind a function name in the namespace registered with this class.

  This mechanism is currently used for the SQL function library, because the implementations of these functions are shipped in a separate JAR file (and this is not available on .NET). If the target function library cannot be loaded, the relevant functions will be reported as being not available.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OnDemandFunctionSet​(Configuration config, java.lang.String namespace, java.lang.String libraryClass)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### OnDemandFunctionSet

          public OnDemandFunctionSet​(Configuration config,
                                     java.lang.String namespace,
                                     java.lang.String libraryClass)

  - ### Method Detail

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Description copied from interface: `FunctionLibrary`
      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called, together with its arity. For legacy reasons, the arity may be set to -1 to mean any arity will do
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Description copied from interface: `FunctionLibrary`
      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the QName of the function being called
        `staticArgs` - May be null; if present, the length of the array must match the value of arity. Contains the expressions supplied statically in arguments to the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

        The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

        `env` - The static context of the function call
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An expression equivalent to a call on the specified function, if one is found; null if no function was found matching the required name and arity.

    - #### copy

          public FunctionLibrary copy()

      Description copied from interface: `FunctionLibrary`
      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Description copied from interface: `FunctionLibrary`
      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private